﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using LogicModule.Nodes.TestHelper;
using LogicModule.ObjectModel;
using LogicNodesSDK.Logic.Examples;
using NUnit.Framework;

namespace ExampleNodesTest
{
  [TestFixture]
  class ToggleTest
  {
    private INodeContext context;
    private Toggle node;

    public ToggleTest()
    {
      context = TestNodeContext.Create();
    }

    [SetUp]
    public void ColorInverterTestSetUp()
    {
      node = new Toggle(context);
    }

    [TearDown]
    public void ColorInverterTestTearDown()
    {
      node = null;
    }

    [Test]
    public void BasicTest()
    {
      node.Execute();
      // Test that Toggle is initialized with true.
      Assert.IsTrue(node.Output.Value);
      node.Execute();
      Assert.IsFalse(node.Output.Value);
      node.Input.Value = 5;
      // Setting a value has no effect. Only the Execute() method toggles the value.
      node.Execute();
      Assert.IsTrue(node.Output.Value);
      node.Execute();
      Assert.IsFalse(node.Output.Value);
      node.Execute();
      Assert.IsTrue(node.Output.Value);
    }
  }
}
